import '../../../models/action_recipe.dart';

abstract class BaseRegexCommandProcessor {
  static const actionCMD =
      "select|choose|copy text|copytext|cut text|cuttext|correct|bold|underline|delete|header|capitalize|unbold|debold|dbold|uncapitalize|remove|capitalise|dcapitalise|decapitalicize|decapitalize|uncapitalize|Uncap|d capitalise|d capitalize|d underline|dunderline|deunderline|ununderline|goto|moveto|move|italicize|italicise|unitalicise|unitalicize";

  /// Used to sort when this processor will run. A lower number give its more
  /// precedence and means it will run earlier than other processor with a
  /// higher number.
  final int precedence = 0;

  /// Attempts to process a command for a recipe. Returns true if the
  /// [regexTestString] matches that of the processor currently running.
  /// The modifications are applied to the [ActionRecipe] provided.
  bool processActionRecipe(ActionRecipe recipe, String regexTestString);
}
