import '../../../models/action_recipe.dart';
import '../../../support/augnito_commands.dart';
import 'base_regex_command_processor.dart';

class GenericGoToCommandProcessor implements BaseRegexCommandProcessor {
  static GenericGoToCommandProcessor? _instance;
  GenericGoToCommandProcessor._internal();

  factory GenericGoToCommandProcessor() {
    return _instance ?? GenericGoToCommandProcessor._internal();
  }

  @override
  int get precedence => 10;

  @override
  bool processActionRecipe(ActionRecipe recipe, _) {
    if (recipe.name.startsWith(AugnitoCommands.goTo)) {
      recipe.name = AugnitoCommands.goTo;
      recipe.searchText = recipe.receivedText.trim().substring(2);
      recipe.searchText = recipe.searchText.trim().substring(2).trim();
      recipe.isCommand = true;
      return true;
    }
    return false;
  }
}
