import '../../../models/action_recipe.dart';
import '../../../support/augnito_commands.dart';
import 'base_regex_command_processor.dart';

class GoToMoveToCommandProcessor implements BaseRegexCommandProcessor {
  static GoToMoveToCommandProcessor? _instance;
  GoToMoveToCommandProcessor._internal();

  factory GoToMoveToCommandProcessor() {
    return _instance ?? GoToMoveToCommandProcessor._internal();
  }

  static const List<String> _matches = ["goto\n", "moveto\n", "move\n"];

  @override
  int get precedence => 1;

  @override
  bool processActionRecipe(ActionRecipe recipe, String regexTestString) {
    if (_matches.contains(regexTestString)) {
      recipe.name = AugnitoCommands.selectLine;
      recipe.nextPrevious = "next";
      recipe.chooseNumber = 1;
      recipe.receivedText = "";
      recipe.isCommand = true;
      recipe.selectFor = "gotoend";
      return true;
    }
    return false;
  }
}
