import '../../../models/action_recipe.dart';
import '../../../support/augnito_commands.dart';
import 'base_regex_command_processor.dart';

class GoToMoveToParagraphCommandProcessor implements BaseRegexCommandProcessor {
  static GoToMoveToParagraphCommandProcessor? _instance;
  GoToMoveToParagraphCommandProcessor._internal();

  factory GoToMoveToParagraphCommandProcessor() {
    return _instance ?? GoToMoveToParagraphCommandProcessor._internal();
  }

  static const List<String> _matches = ["goto\n\n", "moveto\n\n", "move\n\n"];

  @override
  int get precedence => 2;

  @override
  bool processActionRecipe(ActionRecipe recipe, String regexTestString) {
    if (_matches.contains(regexTestString)) {
      recipe.name = AugnitoCommands.selectParagraph;
      recipe.nextPrevious = "next";
      recipe.chooseNumber = 1;
      recipe.receivedText = "";
      recipe.isCommand = true;
      recipe.selectFor = "gotoend";
      return true;
    }
    return false;
  }
}
