import 'dart:collection';

abstract class AugnitoCommands {
  static const selectActiveChar = "selectactivechar";
  static const selectActiveWord = "selectactiveword";
  static const selectActiveLine = "selectactiveline";
  static const selectActiveParagraph = "selectactiveparagraph";

  static const modify = "modify";
  static const choose = "choose";
  static const select = "select";

  static const selectChar = "selectchar";
  static const selectWord = "selectword";
  static const selectLine = "selectline";
  static const selectNextLine = "selectnextline";
  static const selectPreviousLine = "selectpreviousline";
  static const selectParagraph = "selectparagraph";

  static const mark = "mark";
  static const goToLineNumber = "gotolinenumber";
  static const goToParaNumber = "gotoparanumber";

  static const selectAll = "selectall";
  static const selectNextWord = "selectnextword";
  static const selectPreviousWord = "selectpreviousword";

  static const replace = "replace";
  static const unSelectIt = "unselectit";
  static const whatCanISay = "whatcanisay";

  static const selectPreviousParagraph = "selectpreviousparagraph";
  static const selectNextParagraph = "selectnextparagraph";
  static const alignLeft = "alignleft";
  static const alignRight = "alignright";
  static const alignCenter = "aligncenter";
  static const alignJustify = "alignjustify";

  static const number = "number";
  static const showLineNumber = "linenumbershow";
  static const hideLineNumber = "linenumberhide";

  static final singleItCommands = HashSet.from(List.of(const [
    "selectit",
    "headerit",
    "cutit",
    "copyit",
    "boldit",
    "unboldit",
    "italiciseit",
    "italicizeit",
    "unitaliciseit",
    "unitalicizeit",
    "deleteit",
    "underlineit",
    "deunderlineit",
    "ununderlineit",
    "capitaliseit",
    "capitalizeit",
    "uncapitaliseit",
    "uncapitalizeit"
  ]));

  static const startNumberList = "numberliststart";
  static const startBulletList = "bulletliststart";
  static const stopBulletList = "bulletliststop";
  static const stopNumberList = "numberliststop";
  static const stopList = "stoplist";

  static const startBoldText = "startboldtext";
  static const stopBoldText = "stopboldtext";
  static const startCapitalText = "startcapitaltext";
  static const stopCapitalText = "stopcapitaltext";
  static const startBulletText = "startbullettext";
  static const stopBulletText = "stopbullettext";
  static const startItalicText = "startitalictext";
  static const stoptItalicText = "stopitalictext";

  static const newLine = "\n";
  static const nextLineText = "@newline@";

  //Editing your document
  static const deleteIt = "deleteit";
  static const pasteIt = "pasteit";
  static const copyIt = "copyit";
  static const cutIt = "cutit";
  static const headerIt = "headerit";
  static const underlineIt = "underlineit";
  static const deUnderlineIt = "deunderlineit";
  static const boldIt = "boldit";
  static const italicizeIt = "italicizeit";
  static const unBoldIt = "unboldit";
  static const unCapitalizeIt = "unitalicizeit";
  static const capitalizeIt = "capitalizeit";
  static const unCapitalizedIt = "uncapitalizeit";
  static const bulletIt = "bulletit";

  static const boldLastLine = "boldpreviousline";
  static const boldLastWord = "boldpreviousword";
  static const deleteLastLine = "deletepreviousline";
  static const deleteLastWord = "deletepreviousword";

  static const undoIt = "undoit";
  static const redoIt = "redoit";

  static const clearFields = "clearfields";

  // Combination commands
  static const boldAndUnderline = "boldandunderline";

  // Command start
  static const goTo = "goto";
  static const bold = "bold";
  static const delete = "delete";
  static const underline = "underline";
  static const capitalize = "capitalize";
  static const header = "header";
  static const unBold = "unbold";

  static const selectFromNToM = "Selectfromntom";
  static const selectNToM = "Selectntom";
  static const selectNThroughM = "Selectnthroughm";
  static const chooseFromNToM = "choosefromnton";
  static const chooseNToM = "choosenton";
  static const markFromNToM = "markfromntom";
  static const markNToM = "marknton";

  //Dynamic Command
  static const selectNextNWords = "selectnextnwords";
  static const chooseNextNWords = "choosenextnwords";
  static const markNextNWords = "marknextnwords";
  static const selectPreviousNWords = "selectpreviousnwords";
  static const choosePreviousNWords = "choospreviousnwords";
  static const markPreviousNWords = "markpreviousnwords";

  static const unselectX = "unselectx";
  static const unChooseX = "unchoosex";
  static const unMarkX = "unmarkx";

  // Command Key Press
  static const ok = "ok";
  //static const OKAY = "okay";
  //static const ENTER = "enter";
  static const moveUp = "moveup";
  static const moveDown = "movedown";
  static const moveLeft = "moveleft";
  static const moveRight = "moveright";
  static const goToLineStart = "gotolinestart";
  static const goToLineEnd = "gotolineend";
  static const giveTab = "givetab";

  static const giveSpace = "givespace";
  static const backspace = "backspace";
  static const goToDocumentEnd = "gotodocumentend";
  static const goToDocumentStart = "gotodocumentstart";

  static const goToNextParagraph = "gotonextparagraph";
  static const goToPreviousParagraph = "gotopreviousparagraph";

  static const goToNextPage = "gotonextpage";
  static const goToPreviousPage = "gotopreviouspage";
  static const insertPageBreak = "insertpagebreak";

  static const openSquareBracket = "[";
  static const closeSquareBracket = "]";
  static const openTriBracket = "<";
  static const closeTriBracket = ">";

  // Replace Blank
  static const replaceBlanks = "replaceblanks";
  static const replaceNextBlank = "nextblank";
  static const stopReplacingBlanks = "stopreplacingblanks";

  //Fields
  static const nextField = "nextfield";
  static const previousField = "previousfield";
  static const showFields = "showfields";

  // mic
  static const stopMic = "stopmic";
}
